music('deepsparse.ogg')
w = huwalls([(0, 0), (0, 250), '2ndbatch1', (0, 286),
             (0, 400), 'indoor', (0, 400+PACKAGE),
           (0, 600), (440, 600), '2ndbatch3', (440+PACKAGE, 600), (800, 600),
           (800, 536), 'edoor1', (800, 500),
           (800, 350+36), '1stbatch', (800, 350),
           (800, 286), '2ndbatch2', (800, 250),
           (800, 0),
           (400, 0), 'edoor2', (300, 0)],
          counter=True, closed=True,
          bg='level1-lastroom')

p = Player(pos=(250+400, 100+12-16), velo=(0, 0))
ppack, p = hubox(payload=p, rel=('left', w), pos=(-1000, 400), pattern=[((10, 0), 100), ((0, 0), 0), 'set_flag("landed", True)'])

controls(disable=['shoot_beam'])
controls(disable=['shoot_hook'])
controls(disable=['reel_in'])
controls(disable=['reel_out'])

flag('landed')
door(w, 'indoor').open()
delete(ppack, 'right')
e = Enemy(ai=ai.Shoots(), angle=90, shapes=[Circle(8, image="drone")], pattern=[((-3, 0), 30)], size=8, health=10)

d1 = door(w, 'edoor1')
d2 = door(w, 'edoor2')
box, e = enemybox(payload=e, pos=(20, 500), side='right', target=w, targetcut='d1', texture='humanboxwall', bg='humanboxbg')

##e = moving_replace(pos=(800, 518), dir=(-5, 0), time=5,
##                   o1=Circle(8, image="drone"),
##                   o2=Enemy(ai=ai.Shoots(), angle=90,
##                                            shapes=[Circle(8, image="drone")],
##                                            size=8, health=10))

sd = Sequence(
    Dialog("All right Cadet, we've made things a little bit more interesting by putting a drone in there with you. He's not very bright, but he does provide some semblance of a challenge.", characters.Lisa),
    Dialog("Shoot him down. It shouldn't be hard.", characters.Lisa),
    Dialog("Press '%s' to shoot." % (get_control('shoot_bullet'))))

kills(e,
      meanwhile=sd)

dialog("Not bad.", characters.Lisa)
oldhealth = p.get_health()
p.set_health(10)
dialog("Of course, anyone can win if they have superior strength. I'm reducing your armor a bit.", characters.Lisa)
epattern = [((0, 5), 100), ((0, 0), -1)]
w2 = walls([(250, 400), (400, 400), (400, 0), (0, 0), (0, 400), (150, 400)], counter=True, rel=('top', w), pos=(150, -500), pattern=epattern+['d2.open()'], texture='humanboxwall', texturebg="humanboxbg")
positions = [((400-9, 400-16), 180), ((9, 400-16), 0), ((9, 200), 315), \
             ((400-9, 200), 225)]
enemies = []
for pos, a in positions:
    e = enemy(ai=ai.Shoots(), shapes=[Circle(8, image="drone")], rel=w2, pos=pos, angle=a,
              pattern=epattern)
    enemies.append(e)

done = False
dlgs = [Dialog("See if you can negotiate your way through this box.", characters.Lisa), Dialog("It's tough, isn't it? Try using some fancy maneuvering.", characters.Lisa), NoneGoal()]
n = 0
while not done:
    try:
        all(meanwhile=dlgs[n], *map(Kills, enemies))
    except GameOver:
        a = get_angle(p)
        delete(p)
        p = player(pos=(600, 500), velo=(0, 0), health=10, angle=a)
        if n+1 < len(dlgs): n += 1
    else:
        done=True

dialog("Well done.", characters.Lisa)

dialog("Now let's start looking at intelligent adversaries.", characters.Lisa)
dialog("Return to the big room.", characters.Lisa)
p.set_health(*oldhealth)
objectin(p, (0, 0, 800, 600))

dialog("This drone's a little smarter - he'll actually aim for you. Get ready.", characters.Lisa)
ebox, e = package(payload=Enemy(ai=ai.Targets(period=40), shapes=[Circle(8, image="drone")],
                                size=8, health=10, angle=180),
                  rel=('right', w), pos=(500, 350),
                  pattern = [((-5, 0), 100), ((0, 0), 0), 'd1.open()',
                             'delete(ebox, "left")', 'start(e, [((-3, 0), 30), ((0,0), 0)])'],
                  texture='humanboxwall', texturebg='humanboxbg')
d1 = door(w, '1stbatch')
#edoor = door(ebox, 'left')

holed1 = door(w, '2ndbatch1')
holed2 = door(w, '2ndbatch2')
holed3 = door(w, '2ndbatch3')
                  
kills(e)
dialog("Not bad.", characters.Lisa)
dialog("You should be aware that the damage your laser pulses do is directly proportional to your speed: the faster you're flying towards your target, the more your shots will hurt it. Of course, few space battles are won by charging blindly at the adversary.", characters.Lisa)
dialog("Here are a few more drones.", characters.Lisa)
#spawn(Enemy(ai.Targets(period=40), shapes=[Circle(8)], health=20), ('left', 250, 50), ('right', 250, -50), ('bottom', 400, -50))

#for p in [(150, 250), (750, 250), (450, 550)]:

def etype(ai=ai.Targets(period=40), **kwargs):
    return Enemy(ai=ai, shapes=[Circle(8, image="drone")], size=8, health=10, **kwargs)

ebox1, e1 = enemybox(payload=etype(),
                     side='left', target=w, targetcut='holed1', pos=(50, 250), texture='humanboxwall', texturebg='humanboxbg')
ebox2, e2 = enemybox(payload=etype(angle=180),
                     side='right', target=w, targetcut='holed2', pos=(-50, 250), texture='humanboxwall', texturebg='humanboxbg')
ebox3, e3 = enemybox(payload=etype(angle=90),
                     side='bottom', target=w, targetcut='holed3', pos=(440, -50), texture='humanboxwall', texturebg='humanboxbg',
                     size=(PACKAGE, PACKAGE))
all(Kills(e1), Kills(e2), Kills(e3))
set_flag('allkilled', True)

def initfunc(): pass

def moredrones():
    drones = []
    for e, ebox, (mina, maxa) in [(e1, ebox1, (315, 405)), (e2, ebox2, (135, 225)), (e3, ebox3, (45, 135))]:
        if randint(0, 1):
            kwargs = {'ai': ai.Shoots(), 'angle': randint(mina, maxa)}
        else:
            kwargs = {'angle': e.angle}
                      
        e = place(etype(pos=e.finalpos, pattern=ebox.payload.origpattern, **kwargs))
        drones.append(e)
    add_action(KillAll(drones), "set_flag('allkilled', True)")

s2 = switchrepeat(initfunc, moredrones, 'allkilled', dir=(0, 1),
                  goals=[ObjectIn(p, w.rect())],
                  type=HuSwitch, pos=(300, 600), rel=w)
fx(w, 'bgrect', rect=(300-20, 600+THICKNESS, 40, 100))

dialog("Hit the switch on the south wall for more target practice. When you're done, get in the capsule south of your position.", characters.Lisa)
all(Flag('allkilled'), ObjectIn(p, ebox3.rect(), rel=ebox3))

holed3.close()
enable(ebox3, 'top')
start(ebox3, [((0, 10), 0)])
start(p, [((0, 10), 0)])
dialog("Keep in mind that our drones are not nearly as vicious or tough as our real opponents. Out here, we just don't have the material to make them as big or dense.", characters.Lisa)
dialog("I'm sure you'll see what I mean soon enough.", characters.Lisa)

nextlevel = 'level3'
